.\"	$NetBSD: pw_lock.3,v 1.12 2003/08/07 16:45:00 agc Exp $
.\"
.\" Copyright (c) 1995
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software developed by the Computer Systems
.\" Engineering group at Lawrence Berkeley Laboratory under DARPA contract
.\" BG 91-66 and contributed to Berkeley.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd February 17, 2007
.Dt PW_LOCK 3
.Os
.Sh NAME
.Nm pw_lock ,
.Nm pw_mkdb ,
.Nm pw_abort ,
.Nm pw_setprefix ,
.Nm pw_getprefix
.Nd passwd file update functions
.Sh LIBRARY
.Lb libutil
.Sh SYNOPSIS
.In util.h
.Ft int
.Fn pw_lock "int retries"
.Ft int
.Fn pw_mkdb "const char *username" "int secureonly"
.Ft void
.Fn pw_abort "void"
.Ft int
.Fn pw_setprefix "const char *new_prefix"
.Ft "const char *"
.Fn pw_getprefix "void"
.Sh DESCRIPTION
The
.Fn pw_lock ,
.Fn pw_mkdb ,
and
.Fn pw_abort
functions allow a program to update the system passwd database.
.Pp
The
.Fn pw_lock
function attempts to lock the passwd database by creating the file
.Pa /etc/ptmp ,
and returns the file descriptor of that file.
If
.Fa retries
is greater than zero,
.Fn pw_lock
will try multiple times to open
.Pa /etc/ptmp ,
waiting one second between tries.
In addition to being a lock file,
.Pa /etc/ptmp
will also hold the contents of the new passwd file.
.Pp
The
.Fn pw_mkdb
function updates the passwd file from the contents of
.Pa /etc/ptmp .
You should finish writing to and close the file descriptor returned by
.Fn pw_lock
before calling
.Fn pw_mkdb .
If
.Fn pw_mkdb
fails and you do not wish to retry, you should make sure to call
.Fn pw_abort
to clean up the lock file.
If the
.Ar username
argument is not NULL, only database entries pertaining to the specified user
will be modified.
If the
.Ar secureonly
argument is non-zero, only the secure database will be updated.
.Pp
The
.Fn pw_abort
function aborts a passwd file update by deleting
.Pa /etc/ptmp .
The passwd database remains unchanged.
.Pp
The
.Fn pw_setprefix
function defines the root directory used for passwd file updates.
If the prefix is set to
.Pa /newroot
.Fn pw_lock
will operate on
.Pa /newroot/etc/ptmp
afterwards.
The default prefix is an empty string.
.Pp
The
.Fn pw_getprefix
function returns the root directory which is currently used for passwd file
updates.
.Sh RETURN VALUES
The
.Fn pw_lock
and
.Fn pw_mkdb
functions return -1 if they are unable to complete properly.
.Sh FILES
.Bl -tag -width /etc/master.passwd -compact
.It Pa /etc/master.passwd
.It Pa /etc/ptmp
.El
.Sh SEE ALSO
.Xr pw_init 3 ,
.Xr pwd_mkdb 8
